Day8 - C - Largest Rectangle in a Histogram HDU - 1506

A histogram is a polygon composed of a sequence of rectangles aligned at a common base line. The rectangles have equal widths but may have different heights. For example, the figure on the left shows the histogram that consists of rectangles with the heights 2, 1, 4, 5, 1, 3, 3, measured in units where 1 is the width of the rectangles:

Usually, histograms are used to represent discrete distributions, e.g., the frequencies of characters in texts. Note that the order of the rectangles, i.e., their heights, is important. Calculate the area of the largest rectangle in a histogram that is aligned at the common base line, too. The figure on the right shows the largest aligned rectangle for the depicted histogram.

InputThe input contains several test cases. Each test case describes a histogram and starts with an integer n, denoting the number of rectangles it is composed of. You may assume that 1 <= n <= 100000. Then follow n integers h1, ..., hn, where 0 <= hi <= 1000000000. These numbers denote the heights of the rectangles of the histogram in left-to-right order. The width of each rectangle is 1. A zero follows the input for the last test case.OutputFor each test case output on a single line the area of the largest rectangle in the specified histogram. Remember that this rectangle must be aligned at the common base line.Sample Input

7 2 1 4 5 1 3 3
4 1000 1000 1000 1000
0

Sample Output

8
4000

思路:单调队列板子题,注意在单调性出队的时候统计长度,将新入队的长度变长 提供一组数据 7 4 5 6 2 3 3 3 (14不是12
typedef long long LL;
typedef pair<LL, LL> PLL;

const int maxm = 1e5+5; 

int buf[maxm], q[maxm], len[maxm];

int main() {
    ios::sync_with_stdio(false), cin.tie(0);
    int n;
    while(cin >> n && n) {
        LL ans = 0;
        for(int i = 1; i <= n; ++i) {
            cin >> buf[i];
            len[i] = 1;
        }
        buf[n+1] = 0;
        int l = 0, r = -1, cnt;
        bool flag = false;
        for(int i = 1; i <= n+1; ++i) {
            cnt = 0; flag = false;
            while(l <= r && buf[q[r]] > buf[i]) {
                flag = true;
                cnt += len[q[r]];
                ans = max(ans, 1LL*cnt*buf[q[r]]);
                r--;
            }
            q[++r] = i;
            if(flag) len[i] = cnt+1;
        }
        cout << ans << "\n";
    }

    return 0;
}
View Code

也可以用笛卡尔树来做,注意这里并不是严格的笛卡尔树,因为是有相同权值的节点的,一个点的长度就是他后裔的个数+自身(1),搜索时使用记忆化,不然会T

typedef long long LL;
typedef pair<LL, LL> PLL;

const int maxm = 1e5+5; 

int buf[maxm], q[maxm], Left[maxm], Right[maxm], length[maxm];

int getlen(int u) {
    if(length[u]) return length[u];
    int len = 1;
    if(Left[u]) len += getlen(Left[u]);
    if(Right[u]) len += getlen(Right[u]);
    return length[u] = len;
}

int main() {
    ios::sync_with_stdio(false), cin.tie(0);
    int n;
    while(cin >> n && n) {
        LL ans = 0;
        for(int i = 1; i <= n; ++i) Left[i] = Right[i] = length[i] = 0;
        for(int i = 1; i <= n; ++i)
            cin >> buf[i];
        int top = 0;
        for(int i = 1; i <= n; ++i) {
            while(top && buf[q[top]] > buf[i]) {
                Left[i] = q[top];
                top--;
            }
            if(top)
                Right[q[top]] = i;
            q[++top] = i;
        }
        for(int i = 1; i <= n; ++i) {
            int len = 1;
            len = getlen(i);
            ans = max(ans, 1LL*len*buf[i]);
        }
        cout << ans << "\n";
    }

    return 0;
}
View Code

猜你喜欢

转载自www.cnblogs.com/GRedComeT/p/12233437.html